(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../TypeGuards/isUUIDVersion", "../../Enums/UUIDVersions"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const isUUIDVersion_1 = require("../../TypeGuards/isUUIDVersion");
    const UUIDVersions_1 = require("../../Enums/UUIDVersions");
    exports.mergeUUIDOptions = (base, toMerge) => {
        const options = Object.assign({}, base);
        if (toMerge && typeof toMerge === 'object') {
            if (isUUIDVersion_1.isUUIDVersion(toMerge.version)) {
                options.version = toMerge.version;
            }
            if (typeof toMerge.clockSequenceGetter === 'function') {
                options.clockSequenceGetter = toMerge.clockSequenceGetter;
            }
            if (typeof toMerge.nodeIdentifierGetter === 'function') {
                options.nodeIdentifierGetter = toMerge.nodeIdentifierGetter;
            }
            if (typeof toMerge.timestampGetter === 'function') {
                options.timestampGetter = toMerge.timestampGetter;
            }
            if (options.version === UUIDVersions_1.UUIDVersions.Three ||
                options.version === UUIDVersions_1.UUIDVersions.Five) {
                if (toMerge.namespaceId) {
                    options.namespaceId = toMerge.namespaceId;
                }
                if (toMerge.name) {
                    options.name = toMerge.name;
                }
            }
        }
        return options;
    };
    exports.default = exports.mergeUUIDOptions;
});
