(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../getLastResults", "../uintArrayAsBigNumber", "../Enums/UUIDVersions"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const getLastResults_1 = require("../getLastResults");
    const uintArrayAsBigNumber_1 = require("../uintArrayAsBigNumber");
    const UUIDVersions_1 = require("../Enums/UUIDVersions");
    exports.makeVersionOneUUIDValues = (options) => {
        const nodeIdentifier = options.nodeIdentifierGetter(options.version);
        const timestamp = options.timestampGetter(options.version);
        const lastResults = getLastResults_1.getLastResults();
        let clockSequence = (() => {
            if (lastResults &&
                uintArrayAsBigNumber_1.uintArrayAsBigNumber(lastResults.nodeIdentifier).neq(uintArrayAsBigNumber_1.uintArrayAsBigNumber(nodeIdentifier))) {
                return options.clockSequenceGetter(UUIDVersions_1.UUIDVersions.Four);
            }
            else {
                return options.clockSequenceGetter(options.version);
            }
        })();
        let shouldWrite = false;
        if (!lastResults) {
            shouldWrite = true;
        }
        else {
            const oldTimestamp = lastResults.timestamp;
            const oldClockSequence = lastResults.clockSequence;
            if ((oldTimestamp && 'BYTES_PER_ELEMENT' in oldTimestamp) &&
                (oldClockSequence && 'BYTES_PER_ELEMENT' in oldClockSequence)) {
                const oldTimeInt = uintArrayAsBigNumber_1.uintArrayAsBigNumber(oldTimestamp);
                const newTimeInt = uintArrayAsBigNumber_1.uintArrayAsBigNumber(timestamp);
                if (oldTimeInt.geq(newTimeInt)) {
                    clockSequence[1] += 1;
                    if (clockSequence[1] === 0) {
                        clockSequence[0] += 1;
                    }
                    shouldWrite = true;
                }
            }
            if (uintArrayAsBigNumber_1.uintArrayAsBigNumber(clockSequence).neq(uintArrayAsBigNumber_1.uintArrayAsBigNumber(lastResults.clockSequence)) ||
                uintArrayAsBigNumber_1.uintArrayAsBigNumber(nodeIdentifier).neq(uintArrayAsBigNumber_1.uintArrayAsBigNumber(lastResults.nodeIdentifier))) {
                shouldWrite = true;
            }
        }
        return {
            clockSequence,
            nodeIdentifier,
            shouldWrite,
            timestamp,
        };
    };
    exports.default = exports.makeVersionOneUUIDValues;
});
