(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../getHashFromNamespaceIdAndName", "../strings"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const getHashFromNamespaceIdAndName_1 = require("../getHashFromNamespaceIdAndName");
    const strings_1 = require("../strings");
    exports.makeVersionThreeOrFiveUUIDValues = (options) => {
        if (!options || !options.namespaceId) {
            throw new Error(strings_1.strings.NAMESPACE_ID_MISSING);
        }
        else if (!options.name) {
            throw new Error(strings_1.strings.NAME_MISSING);
        }
        const hash = getHashFromNamespaceIdAndName_1.getHashFromNamespaceIdAndName(options.version, options.namespaceId, options.name);
        const clockSequence = options.clockSequenceGetter(options.version, hash);
        const nodeIdentifier = options.nodeIdentifierGetter(options.version, hash);
        const timestamp = options.timestampGetter(options.version, hash);
        return {
            clockSequence,
            nodeIdentifier,
            timestamp,
        };
    };
    exports.default = exports.makeVersionThreeOrFiveUUIDValues;
});
