(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../strings", "./UUIDOptions/UUIDOptions", "./UUID", "../getHashFromNamespaceIdAndName"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const strings_1 = require("../strings");
    const UUIDOptions_1 = require("./UUIDOptions/UUIDOptions");
    const UUID_1 = require("./UUID");
    const getHashFromNamespaceIdAndName_1 = require("../getHashFromNamespaceIdAndName");
    exports.uuidFactory = (options = new UUIDOptions_1.UUIDOptions()) => {
        if (/^[35]$/.test(String(options.version))) {
            if (!options.namespaceId) {
                throw new Error(strings_1.strings.NAMESPACE_ID_MISSING);
            }
            else if (!options.name) {
                throw new Error(strings_1.strings.NAME_MISSING);
            }
            return new Promise((resolve) => {
                getHashFromNamespaceIdAndName_1.getHashFromNamespaceIdAndName(options.version, options.namespaceId, options.name).then((hash) => {
                    resolve(new UUID_1.UUID(Object.assign({}, options, { hash, })));
                });
            });
        }
        else {
            return Promise.resolve(new UUID_1.UUID(options));
        }
    };
    exports.default = exports.uuidFactory;
});
