(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./strings", "./Enums/UUIDVersions"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const strings_1 = require("./strings");
    const UUIDVersions_1 = require("./Enums/UUIDVersions");
    const MD5 = require('crypto-js/md5');
    const SHA1 = require('crypto-js/sha1');
    const hex = require('crypto-js/enc-hex');
    exports.getHashFromNamespaceIdAndName = (version, namespaceId, name) => {
        if (!namespaceId) {
            throw new Error(strings_1.strings.NAMESPACE_ID_MISSING);
        }
        else if (!name) {
            throw new Error(strings_1.strings.NAME_MISSING);
        }
        const toHash = namespaceId + name;
        const hash = version === UUIDVersions_1.UUIDVersions.Three ? MD5(toHash) : SHA1(toHash);
        return hex.stringify(hash);
    };
    exports.default = exports.getHashFromNamespaceIdAndName;
});
