(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "fs", "./TypeGuards/isValidLastResults", "os", "path"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const fs_1 = require("fs");
    const isValidLastResults_1 = require("./TypeGuards/isValidLastResults");
    const os_1 = require("os");
    const path_1 = require("path");
    let lastResults = null;
    exports.getLastResults = () => {
        if (lastResults) {
            return lastResults;
        }
        let tempLastResults;
        try {
            const fileStr = fs_1.readFileSync(path_1.join(os_1.homedir(), 'uuid'), 'utf8');
            tempLastResults = JSON.parse(fileStr);
        }
        catch (e) { }
        if (isValidLastResults_1.isValidLastResults(tempLastResults)) {
            lastResults = tempLastResults;
            return lastResults;
        }
        else {
            return {};
        }
    };
    exports.default = exports.getLastResults;
});
