(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "os", "./strings"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const os_1 = require("os");
    const strings_1 = require("./strings");
    function getMAC() {
        const interfaces = os_1.networkInterfaces();
        const interfaceNames = Object.keys(interfaces);
        for (let ii = 0; ii < interfaceNames.length; ii += 1) {
            const interfaceName = interfaceNames[ii];
            const _interface = interfaces[interfaceName];
            for (let jj = 0; jj < _interface.length; jj += 1) {
                const val = _interface[jj];
                if (val && typeof val === 'object') {
                    const mac = val.mac;
                    const empty = '00:00:00:00:00:00';
                    if (typeof mac === 'string' && mac && mac !== empty) {
                        const bytes = mac
                            .split(':')
                            .map((byteStr) => parseInt(byteStr, 16));
                        if (bytes.length === 6 &&
                            bytes.filter((num) => num >= 0 && num <= 255).length === 6) {
                            return new Uint8Array(bytes);
                        }
                    }
                }
            }
        }
        throw new Error(strings_1.strings.MAC_ADDRESS_UNAVAILABLE);
    }
    exports.getMAC = getMAC;
    exports.default = getMAC;
});
