(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./isNode", "crypto"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const isNode_1 = require("./isNode");
    const crypto_1 = require("crypto");
    exports.randomBytesGenerator = (size) => {
        if (isNode_1.isNode()) {
            return new Uint8Array(crypto_1.randomBytes(size));
        }
        else {
            const crypto = (window.crypto || window.msCrypto);
            const quota = 65536;
            const arr = new Uint8Array(size);
            for (let ii = 0; ii < size; ii += quota) {
                crypto.getRandomValues(arr.subarray(ii, ii + Math.min(size - ii, quota)));
            }
            return arr;
        }
    };
    exports.default = exports.randomBytesGenerator;
});
