(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "fs", "./TypeGuards/isValidLastResults", "os", "path", "./strings"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const fs_1 = require("fs");
    const isValidLastResults_1 = require("./TypeGuards/isValidLastResults");
    const os_1 = require("os");
    const path_1 = require("path");
    const strings_1 = require("./strings");
    exports.writeNewResults = (lastResults) => {
        if (!isValidLastResults_1.isValidLastResults(lastResults)) {
            throw new Error(strings_1.strings.UUID_LAST_RESULTS_INVALID);
        }
        const formattedLastResults = {
            clockSequence: Array.prototype.slice.call(lastResults.clockSequence),
            nodeIdentifier: Array.prototype.slice.call(lastResults.nodeIdentifier),
            timestamp: Array.prototype.slice.call(lastResults.timestamp),
        };
        try {
            fs_1.writeFileSync(path_1.join(os_1.homedir(), 'uuid'), JSON.stringify(formattedLastResults), {
                encoding: 'utf8',
            });
        }
        catch (e) {
            throw new Error('Could not write results.');
        }
    };
    exports.default = exports.writeNewResults;
});
