import { IUUID } from './IUUID';
import { IUUIDOptions } from './UUIDOptions/IUUIDOptions';
import { UUIDVersions } from '../Enums/UUIDVersions';
export declare class UUID implements IUUID {
    constructor(argOptions?: Partial<IUUIDOptions>);
    readonly id: string;
    private __version;
    readonly version: UUIDVersions;
    private __timestamp;
    readonly timestamp: Uint8Array;
    readonly timeLow: Uint8Array;
    readonly timeMid: Uint8Array;
    readonly timeHigh: Uint8Array;
    private __clockSequence;
    readonly clockSequence: Uint8Array;
    readonly clockSequenceLow: Uint8Array;
    readonly clockSequenceHigh: Uint8Array;
    readonly reserved: Uint8Array;
    readonly clockSequenceHighAndReserved: Uint8Array;
    private __nodeIdentifier;
    readonly nodeIdentifier: Uint8Array;
    static parse(text: string): IUUID;
    toString(): string;
}
export default UUID;
