import { isUUIDVersion, } from '../../TypeGuards/isUUIDVersion';
import { UUIDVersions, } from '../../Enums/UUIDVersions';
export const mergeUUIDOptions = (base, toMerge) => {
    const options = Object.assign({}, base);
    if (toMerge && typeof toMerge === 'object') {
        if (isUUIDVersion(toMerge.version)) {
            options.version = toMerge.version;
        }
        if (typeof toMerge.clockSequenceGetter === 'function') {
            options.clockSequenceGetter = toMerge.clockSequenceGetter;
        }
        if (typeof toMerge.nodeIdentifierGetter === 'function') {
            options.nodeIdentifierGetter = toMerge.nodeIdentifierGetter;
        }
        if (typeof toMerge.timestampGetter === 'function') {
            options.timestampGetter = toMerge.timestampGetter;
        }
        if (options.version === UUIDVersions.Three ||
            options.version === UUIDVersions.Five) {
            if (toMerge.namespaceId) {
                options.namespaceId = toMerge.namespaceId;
            }
            if (toMerge.name) {
                options.name = toMerge.name;
            }
        }
    }
    return options;
};
export default mergeUUIDOptions;
