import { getLastResults, } from '../getLastResults';
import { uintArrayAsBigNumber, } from '../uintArrayAsBigNumber';
import { UUIDVersions, } from '../Enums/UUIDVersions';
export const makeVersionOneUUIDValues = (options) => {
    const nodeIdentifier = options.nodeIdentifierGetter(options.version);
    const timestamp = options.timestampGetter(options.version);
    const lastResults = getLastResults();
    let clockSequence = (() => {
        if (lastResults &&
            uintArrayAsBigNumber(lastResults.nodeIdentifier).neq(uintArrayAsBigNumber(nodeIdentifier))) {
            return options.clockSequenceGetter(UUIDVersions.Four);
        }
        else {
            return options.clockSequenceGetter(options.version);
        }
    })();
    let shouldWrite = false;
    if (!lastResults) {
        shouldWrite = true;
    }
    else {
        const oldTimestamp = lastResults.timestamp;
        const oldClockSequence = lastResults.clockSequence;
        if ((oldTimestamp && 'BYTES_PER_ELEMENT' in oldTimestamp) &&
            (oldClockSequence && 'BYTES_PER_ELEMENT' in oldClockSequence)) {
            const oldTimeInt = uintArrayAsBigNumber(oldTimestamp);
            const newTimeInt = uintArrayAsBigNumber(timestamp);
            if (oldTimeInt.geq(newTimeInt)) {
                clockSequence[1] += 1;
                if (clockSequence[1] === 0) {
                    clockSequence[0] += 1;
                }
                shouldWrite = true;
            }
        }
        if (uintArrayAsBigNumber(clockSequence).neq(uintArrayAsBigNumber(lastResults.clockSequence)) ||
            uintArrayAsBigNumber(nodeIdentifier).neq(uintArrayAsBigNumber(lastResults.nodeIdentifier))) {
            shouldWrite = true;
        }
    }
    return {
        clockSequence,
        nodeIdentifier,
        shouldWrite,
        timestamp,
    };
};
export default makeVersionOneUUIDValues;
