import { getHashFromNamespaceIdAndName, } from '../getHashFromNamespaceIdAndName';
import { strings, } from '../strings';
export const makeVersionThreeOrFiveUUIDValues = (options) => {
    if (!options || !options.namespaceId) {
        throw new Error(strings.NAMESPACE_ID_MISSING);
    }
    else if (!options.name) {
        throw new Error(strings.NAME_MISSING);
    }
    const hash = getHashFromNamespaceIdAndName(options.version, options.namespaceId, options.name);
    const clockSequence = options.clockSequenceGetter(options.version, hash);
    const nodeIdentifier = options.nodeIdentifierGetter(options.version, hash);
    const timestamp = options.timestampGetter(options.version, hash);
    return {
        clockSequence,
        nodeIdentifier,
        timestamp,
    };
};
export default makeVersionThreeOrFiveUUIDValues;
