import { strings, } from '../strings';
import { UUIDOptions, } from './UUIDOptions/UUIDOptions';
import { UUID, } from './UUID';
import { getHashFromNamespaceIdAndName } from '../getHashFromNamespaceIdAndName';
export const uuidFactory = (options = new UUIDOptions()) => {
    if (/^[35]$/.test(String(options.version))) {
        if (!options.namespaceId) {
            throw new Error(strings.NAMESPACE_ID_MISSING);
        }
        else if (!options.name) {
            throw new Error(strings.NAME_MISSING);
        }
        return new Promise((resolve) => {
            getHashFromNamespaceIdAndName(options.version, options.namespaceId, options.name).then((hash) => {
                resolve(new UUID(Object.assign({}, options, { hash, })));
            });
        });
    }
    else {
        return Promise.resolve(new UUID(options));
    }
};
export default uuidFactory;
