import { isNode, } from './isNode';
import { randomBytes, } from 'crypto';
export const randomBytesGenerator = (size) => {
    if (isNode()) {
        return new Uint8Array(randomBytes(size));
    }
    else {
        const crypto = (window.crypto || window.msCrypto);
        const quota = 65536;
        const arr = new Uint8Array(size);
        for (let ii = 0; ii < size; ii += quota) {
            crypto.getRandomValues(arr.subarray(ii, ii + Math.min(size - ii, quota)));
        }
        return arr;
    }
};
export default randomBytesGenerator;
